#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>


/* defines for Track.Action */
#define MUTE		0
#define PLAY	    1
#define REC         2

/* defines for opening device(s) */
#define PLAYTRACKS          0
#define RECTRACKS           1
#define PLAYANDRECTRACKS    2

/* no other formats work on intel machines (with "normal" soundcards) */
#define BIT8		AFMT_U8
#define BIT16		AFMT_S16_LE

#define PLAYDIRECT	0
#define PLAYMIXFILE	1
#define PLAYMEMORY  2

#define RECDIRECT	0
#define RECMEMORY	1



#ifdef __AS_AUDIO

int _OpenSoundDeviceForPlay(void);
int _OpenSoundDeviceForRec(void);
int _OpenSoundDeviceForPlayAndRec(void);
int _OpenSoundDevice(int Mode);

int _SetupSoundDeviceSampleRatePlay(int);
int _SetupSoundDeviceResetPlay(void);
int _SetupSoundDeviceFormatPlay(int);
int _SetupSoundDeviceChannelsPlay(int);
int _SetupSoundDeviceSetBufferSizePlay(int Fragments);
int _SetupSoundDeviceFlushAudioPlay(void);

int _SetupSoundDeviceSampleRateRec(int);
int _SetupSoundDeviceResetRec(void);
int _SetupSoundDeviceFormatRec(int);
int _SetupSoundDeviceChannelsRec(int);
int _SetupSoundDeviceSetBufferSizeRec(int Fragments);

int _SetupSoundDeviceSetFullDuplex(void);
int _SetupSoundDeviceCheckFullDuplex(void);

int _SetupSoundDeviceGetPlayInfo(void);
int _SetupSoundDeviceGetRecInfo(void);
int _SetupSoundDeviceGetFullDuplexInfo(void);


#else


/* only this functions should be used externally */
extern int InitSoundDevice(int Mode);
extern int CloseSoundDevice(void);
extern int PlayBufferToDevice (unsigned char *Buffer, int Size);
extern int RecBufferFromDevice (unsigned char *Buffer, int Size);
extern int FlushSoundDevice(void);     /* waits until the last bytes has been played */
extern int GetBestPlayInfo(void);
extern int GetBestRecInfo(void);
extern int GetBestDuplexInfo(void);
extern int TestPlayInfo(void);
extern int TestRecInfo(void);
extern int TestDuplexInfo(void);


#endif
