/* some useful types and macros */

//#define DEBUG

#define VERSION "v 0.1"

#define OFF  0
#define ON   1
#define NO   0
#define YES  1


#define CACHESIZEFAK        2         
// #define DISBUFSIZE       1600
#define MAXFILES            8
#define PEAK_SAMPLE_SKIP  100


struct tPrg
{
  char ErrorMsg[80];              /* string for error messages */
  int ErrorLevel;                 /* ERR_WARNING, ERR_CRITICAL, ERR_PANIC */

  Window WaitWin;
  int WaitWinWidth;
  int WaitWinHeight;
  int WaitWinProgress;
  int WaitWinVisible;
  char WaitWinMsg[80];

  char HomeDir[200];              /* what do you think it stands for ?? */
  char AudioDir[200];             /* default directory for audio files */
  char ProjectFileName[100];      /* subdir in AudioDir and name of project */

  char MixerApp[200];             /* name of mixer appl. ('kmix', 'xmix', ...) */
  int HideWins;                   /* YES or NO, all wins are hidden while recording (if YES) */
  int RecCountdown;               /* time to wait (in secs.) before rec starts */
  
  int VUMeterWinVisible;
  int TrackWinVisible;

  int StopAction;
};


struct tAudio
{
  char DeviceNamePlay[30];        /* string for the play-device */
  char DeviceNameRec[30];         /* string for the rec-device */
  int DevicePlay;                 /* number from open() */
  int DeviceRec;                  /* number from open() */
  int FullDuplex;                 /* 0=OFF; 1=ON */
  long SampleRate;                /* 8000, 11025, 22050, 44100 */
  int Bits;                       /* 8 or 16 */
  int Channels;                   /* 1 or 2 ( 1 == always mono rec and play) */

  int PlayFragments;              /* info for PLAY-only mode (and 2 soundcards) */
  int PlayFragstotal;
  int PlayFragsize;
  int PlayBytes;
  int PlayInfoTested;

  int RecFragments;               /* info for REC-only mode (and 2 soundcards) */
  int RecFragstotal;
  int RecFragsize;
  int RecBytes;
  int RecInfoTested;

  int DuplexPlayFragments;           /* info for full duplex play (1 soundcard) */
  int DuplexPlayFragstotal;
  int DuplexPlayFragsize;
  int DuplexPlayBytes;
  int DuplexRecFragments;           /* info for full duplex play (1 soundcard) */
  int DuplexRecFragstotal;
  int DuplexRecFragsize;
  int DuplexRecBytes;
  int DuplexInfoTested;

  int RecMode;                    /* RECDIRECT or RECMEMORY */
  int PlayMode;                   /* PLAYDIRECT or MIXFILE, performance issue */
};

struct tTracks
{
  Window Win;              /* XWindows: the track window */
  int WinWidth;            /* actual width of the track window */
  int WinHeight;           /* actual height of the track window */
  int Height;              /* actual height of any track in the window */
  int Width;               /* actual width of any track in the window */
  int NrOfTracks;
};

struct tOpt                /* joins all options together in a handy structure */
{
  struct tPrg Prg;
  struct tAudio Audio;
  struct tTracks Tracks;
};

struct tAudioTrack
{
  char Name[30];           /* track name (displayed in window) */
  char FileName[300];      /* the corresponding file on your hd */
  FILE *File;              /* the file itself */
  int Action;              /* one of MUTE, PLAY, REC */
  char *PeakSamples;       /* Buffer for displaying samples */
  long PeakSampleLenght;   /* Lenght of the Buffer (in chars) */
  int Volume;              /* Playback-only volume (rec-vol. is given by sys-mixer) */
  int Pan;                 /* balance, if more the 1 out-channel ( <0=le, 0=mi, >0=ri) */
  int Selected;
  struct tAudioTrack *next;
  
};


#ifndef __AS_MAIN

extern FD_fMenu *fd_fMenu;              /* all declared in main.c */
extern FD_fSetPrg *fd_fSetPrg;
extern FD_fSetAudio *fd_fSetAudio;
extern FD_fTracks *fd_fTracks;
extern FD_fMeter *fd_fMeter;
extern FD_fStop *fd_fStop;
extern struct tOpt *Opt;                /* (decl. in main.c) static, accessed through pointer */
extern struct tAudioTrack *TrackList;  /* (decl. in main.c) dynamic struct */

#endif
