#ifndef __AS_MAIN
#define __AS_MAIN
#endif


#include <stdlib.h>
#include "forms.h"
#include "xwin2.h"
#include "global.h"
#include "file.h"
#include "error.h"
#include "windows.h"


   FD_fMenu *fd_fMenu;              /* various windows */
   FD_fSetPrg *fd_fSetPrg;
   FD_fSetAudio *fd_fSetAudio;
   FD_fTracks *fd_fTracks;
   FD_fMeter *fd_fMeter;
   FD_fStop *fd_fStop;

   
   struct tOpt sOpt;                        /* the settings struct */
   struct tOpt *Opt=(struct tOpt *)&sOpt;   /* and it's pointer */
   struct tAudioTrack *TrackList=NULL;     /* all audio tracks are managed this way */

int main(int argc, char *argv[])
{

  fl_initialize(&argc, argv, 0, 0, 0);
  fd_fMenu = create_form_fMenu();
  fd_fSetPrg = create_form_fSetPrg();
  fd_fSetAudio = create_form_fSetAudio();
  fd_fTracks = create_form_fTracks();
  fd_fMeter = create_form_fMeter();
  fd_fStop = create_form_fStop();
 

  fl_show_form(fd_fMenu->fMenu,FL_PLACE_CENTER,FL_FULLBORDER,"XhdREC");
  

  /* TODO: init vars */
  sprintf((char *)&Opt->Prg.HomeDir,"%s",getenv("HOME"));
  sprintf((char *)&Opt->Prg.ProjectFileName,"");
  Opt->Prg.VUMeterWinVisible=YES;
  Opt->Prg.TrackWinVisible=NO;
  Opt->Prg.StopAction=NO;
  Opt->Prg.VUMeterWinVisible=NO;
  Opt->Prg.TrackWinVisible=NO;
  Opt->Prg.WaitWin=0;
  Opt->Prg.WaitWinHeight=0;
  Opt->Prg.WaitWinWidth=0;
  Opt->Prg.WaitWinProgress=0;
  Opt->Prg.WaitWinVisible=NO;
  sprintf((char *)&Opt->Prg.WaitWinMsg,"");

  Opt->Tracks.Height=100;
  Opt->Tracks.NrOfTracks=0;
  Opt->Audio.DevicePlay=0;
  Opt->Audio.DeviceRec=0;
  Opt->Audio.PlayInfoTested=NO;
  Opt->Audio.RecInfoTested=NO;
  Opt->Audio.DuplexInfoTested=NO;

  fl_set_form_title(fd_fTracks->fTracks,"UNTITLED");

  /* READ CONFIG FILE */
  if(ReadConfigFile()!=0)
  {
    ShowErrorMsg();
    /* INIT VARS, IF READ FAILS */
    ReadProgramSettingsWin();
    ReadAudioSettingsWin();
    if(fl_show_question("should i create a new config file ?",2)!=0)
    {
      if(CreateConfigFile()!=0)
        ShowErrorMsg();
    }
    fl_show_messages("please, fill in the missing options\nin the program- and audio-settings menu\nand save the configuration");
  }

  /* STORE VAR VALUES IN SETTING_WINDOWS */
  UpdateProgramSettingsWin();
  UpdateAudioSettingsWin();



/*
  if(Opt->Prg.VUMeterWinVisible==YES)
    fl_show_form(fd_fMeter->fMeter,FL_PLACE_CENTER,FL_FULLBORDER,"VU Meter");
  
  if(Opt->Prg.TrackWinVisible==YES)
    ShowTrackWin();
*/    
  
  fl_do_forms();
  return 0;
}
